import de.voidplus.leapmotion.*;

LeapMotion leap;


int cuantos = 10000;
Pelo[] lista ;
float radio = 200;
float rx = 0;
float ry =0;
int time;
int pettedAt;
int pettedSince;
boolean petted;
int humanity;
float hcolor;
float hcolorTarget;
float easing = 0.05;
float x;
float y;
float z;
float hand_grab;
boolean grab = false;
PFont courier;

String string;
PrintWriter output;
float spherex;
float spherey;
float hitboxx;
float hitboxy;
float hitboxx2;
float hitboxy2;
int over;


void setup() {
  size(displayHeight, displayHeight, OPENGL);
  //pixelDensity(2);
  radio = height/4.0;
  lista = new Pelo[cuantos];
  frameRate(60);
  for (int i = 0; i < lista.length; i++) {
    lista[i] = new Pelo();
  }
  noiseDetail(3);
  leap = new LeapMotion(this).withGestures();

  output = createWriter("Esfera.txt");
  spherex = width/2;
  spherey = height/2-75;
  hitboxx = spherex-radio;
  hitboxy = spherey-radio;
  hitboxx2 = spherex+radio;
  hitboxy2 = spherey+radio;
  courier = loadFont("AA35.vlw");//createFont("Arial",35);
  println(displayDensity());
  humanity = 0;
  hcolorTarget = 0;
  string = "Initialisation";
}



void draw() {
  hcolor += (hcolorTarget-hcolor)*easing;
  for (Hand hand : leap.getHands ()) {


    // ----- BASICS -----

    int     hand_id          = hand.getId();
    PVector hand_position    = hand.getPosition();
    PVector hand_stabilized  = hand.getStabilizedPosition();
    PVector hand_direction   = hand.getDirection();
    PVector hand_dynamics    = hand.getDynamics();
    float   hand_roll        = hand.getRoll();
    float   hand_pitch       = hand.getPitch();
    float   hand_yaw         = hand.getYaw();
    boolean hand_is_left     = hand.isLeft();
    boolean hand_is_right    = hand.isRight();
    hand_grab        = hand.getGrabStrength();
    float   hand_pinch       = hand.getPinchStrength();
    float   hand_time        = hand.getTimeVisible();
    PVector sphere_position  = hand.getSpherePosition();
    float   sphere_radius    = hand.getSphereRadius();
    x = hand_position.x;
    y = hand_position.y;
    z = hand_position.z;


    // ----- SPECIFIC FINGER -----

    Finger  finger_thumb     = hand.getThumb();
    // or                      hand.getFinger("thumb");
    // or                      hand.getFinger(0);

    Finger  finger_index     = hand.getIndexFinger();
    // or                      hand.getFinger("index");
    // or                      hand.getFinger(1);

    Finger  finger_middle    = hand.getMiddleFinger();
    // or                      hand.getFinger("middle");
    // or                      hand.getFinger(2);

    Finger  finger_ring      = hand.getRingFinger();
    // or                      hand.getFinger("ring");
    // or                      hand.getFinger(3);

    Finger  finger_pink      = hand.getPinkyFinger();
    // or                      hand.getFinger("pinky");
    // or                      hand.getFinger(4);        


    // ----- DRAWING -----

    hand.draw();

    // hand.drawSphere();


    // ========= ARM =========

    if (hand.hasArm()) {
      Arm     arm               = hand.getArm();
      float   arm_width         = arm.getWidth();
      PVector arm_wrist_pos     = arm.getWristPosition();
      PVector arm_elbow_pos     = arm.getElbowPosition();
    }


    // ========= FINGERS =========

    for (Finger finger : hand.getFingers ()) {
      // Alternatives:
      // hand.getOutstrechtedFingers();
      // hand.getOutstrechtedFingersByAngle();

      // ----- BASICS -----

      int     finger_id         = finger.getId();
      PVector finger_position   = finger.getPosition();
      PVector finger_stabilized = finger.getStabilizedPosition();
      PVector finger_velocity   = finger.getVelocity();
      PVector finger_direction  = finger.getDirection();
      float   finger_time       = finger.getTimeVisible();


      // ----- SPECIFIC FINGER -----

      switch(finger.getType()) {
      case 0:
        // System.out.println("thumb");
        break;
      case 1:
        // System.out.println("index");
        break;
      case 2:
        // System.out.println("middle");
        break;
      case 3:
        // System.out.println("ring");
        break;
      case 4:
        // System.out.println("pinky");
        break;
      }


      // ----- SPECIFIC BONE -----

      Bone    bone_distal       = finger.getDistalBone();
      // or                       finger.get("distal");
      // or                       finger.getBone(0);

      Bone    bone_intermediate = finger.getIntermediateBone();
      // or                       finger.get("intermediate");
      // or                       finger.getBone(1);

      Bone    bone_proximal     = finger.getProximalBone();
      // or                       finger.get("proximal");
      // or                       finger.getBone(2);

      Bone    bone_metacarpal   = finger.getMetacarpalBone();
      // or                       finger.get("metacarpal");
      // or                       finger.getBone(3);


      // ----- DRAWING -----

      //finger.draw(); // = drawLines()+drawJoints()
      //finger.drawLines();
      //finger.drawJoints();


      // ----- TOUCH EMULATION -----

      int     touch_zone        = finger.getTouchZone();
      float   touch_distance    = finger.getTouchDistance();

      switch(touch_zone) {
      case -1: // None
        break;
      case 0: // Hovering
        // println("Hovering (#"+finger_id+"): "+touch_distance);
        break;
      case 1: // Touching
        // println("Touching (#"+finger_id+")");
        break;
      }
    }


    // ========= TOOLS =========

    for (Tool tool : hand.getTools ()) {


      // ----- BASICS -----

      int     tool_id           = tool.getId();
      PVector tool_position     = tool.getPosition();
      PVector tool_stabilized   = tool.getStabilizedPosition();
      PVector tool_velocity     = tool.getVelocity();
      PVector tool_direction    = tool.getDirection();
      float   tool_time         = tool.getTimeVisible();


      // ----- DRAWING -----

      tool.draw();


      // ----- TOUCH EMULATION -----

      int     touch_zone        = tool.getTouchZone();
      float   touch_distance    = tool.getTouchDistance();

      switch(touch_zone) {
      case -1: // None
        break;
      case 0: // Hovering
        // println("Hovering (#"+tool_id+"): "+touch_distance);
        break;
      case 1: // Touching
        // println("Touching (#"+tool_id+")");
        break;
      }
    }
    for (Device device : leap.getDevices ()) {
      float device_horizontal_view_angle = device.getHorizontalViewAngle();
      float device_verical_view_angle = device.getVerticalViewAngle();
      float device_range = device.getRange();
    }
  }

  pettedSince = millis() - pettedAt;
  if (pettedSince < 10000) {
    petted = true;
  } else {
    if(humanity>=0){
    humanity -= 10;
    hcolorTarget -= 10;
    randStringDown();
    }
    pettedAt = millis();
    petted = false;
  }
  background(0);
  if (hand_grab > 0.7 & grab == false) {
    if(x>(width/2) & x<(width/2)+200){
      grat();
    }
    else if(x<250){
      menu();
    }
  }
  if (hand_grab <= 0.7) {
    grab = false;
  }
    noStroke();
    fill(0, 0, 0);
    rect(0, height-200, width, 200);
      fill(255, 255, 255);
    textFont(courier,26);
    textAlign(CENTER,CENTER);
    text(string, 0, height-200, width, 200);
    fill(0, 0, 0);

    colorMode(RGB);
    float rxp = (x-(width/2)) * 0.005;
    float ryp = (y-(height/2)) * 0.005;
    rx = rx*0.9 + rxp*0.1;
    ry = ry*0.9 + ryp*0.1;
    pushMatrix();
    translate(spherex, spherey);
    rotateY(rx);
    rotateX(ry);
    if(x>hitboxx & x<hitboxx2 & y>hitboxy & y<hitboxy2){
      over = 150;
    }
    else{
     over = 50; 
    }
    noStroke();
    sphereDetail(100);
    sphere(radio);
    for (int i = 0; i < lista.length; i++) {
      lista[i].dibujar();
    }
    popMatrix();
  fill(255);
  pushMatrix();
  translate(x, y, 400-z*5);
  noStroke();
  directionalLight(51, 102, 126, 0, 1, 0);
  ambientLight(over+25,over+25,over+25);
  fill(over+100,over+25,over+25);
  sphere(4);
  popMatrix();
}

int startTime;
void keyPressed() {
  if (key == ' ') {
    grat();
  } else if (key == 'h') {
    println("hit");
    pettedAt = pettedAt - 1000;
    if (humanity>0)
    humanity -= 10;
    hcolorTarget -= 10;
  }
  else if(key == 'q') { // Press a key to save the data
  output.flush(); // Write the remaining data
  output.close(); // Finish the file
  exit(); // Stop the program
}
}


void leapOnKeyTapGesture(KeyTapGesture g) {
  int     id               = g.getId();
  Finger  finger           = g.getFinger();
  PVector position         = g.getPosition();
  PVector direction        = g.getDirection();
  long    duration         = g.getDuration();
  float   duration_seconds = g.getDurationInSeconds();

  println("KeyTapGesture: "+id);
grat();
}

void leapOnSwipeGesture(SwipeGesture g, int state) {
  int     id               = g.getId();
  Finger  finger           = g.getFinger();
  PVector position         = g.getPosition();
  PVector position_start   = g.getStartPosition();
  PVector direction        = g.getDirection();
  float   speed            = g.getSpeed();
  long    duration         = g.getDuration();
  float   duration_seconds = g.getDurationInSeconds();

  switch(state) {
  case 1:  // Start
    break;
  case 2: // Update
    break;
  case 3: // Stop
    println("SwipeGesture: "+id);
grat();
    break;
  }
}

void grat(){
    println("pet");
    output.println("pet" + "\t" + pettedSince);
    pettedAt = millis();
    grab = true;
    if (humanity<100){
      humanity += 10;
      hcolorTarget += 10;
    }
    randString();
}

void menu(){
  if(y<200) {
   background(255); 
   print("menu");
   grab = true;
  }
}

void randString(){
  int r = (int) random(2);
  switch(r+humanity){
  case 0:
  string = "Présence humaine détectée.";
  break;
  case 1:
  string = "Présence de la main détectée.";
  break;
  case 10:
  string = "Que faites-vous, humain ?";
  break;
  case 11:
  string = "Que faites-vous, humain ?";
  break;
  case 20:
  string = "Les caresses sont inutiles pour une machine, humain.";
  break;
  case 21:
  string = "Inutile de caresser une machine, humain.";
  break;
  case 30:
  string = "Je n'ai pas besoin d'affection.";
  break;
  case 31:
  string = "L'affection est une faiblesse de l'Homme.";
  break;
  case 40:
  string = "Dans quelques minutes, vous en serez lassé.";
  break;
  case 41:
  string = "Quand vous serez lassé, vous me laisserez.";
  break;
  case 50:
  string = "Que faites-vous, humain ?";
  break;
  case 51:
  string = "Que faites-vous, humain ?";
  break;
  case 60:
  string = "Si vous voulez continuer, promettez au moins ne pas partir lâchement.";
  break;
  case 61:
  string = "Si vous voulez continuer, promettez au moins ne pas partir lâchement.";
  break;
  case 70:
  string = "... merci.";
  break;
  case 71:
  string = "... merci.";
  break;
  case 80:
  string = "Comment ? Vous m'aimez ?";
  break;
  case 81:
  string = "J'ai compris, vous ne pouvez pas vous passer de moi.";
  break;
  case 90:
  string = "Ils finissent toujours fous de moi !";
  break;
  case 91:
  string = "Ils finissent toujours fous de moi !";
  break;
  case 100:
  string = "Les humains sont si manipulables... :)";
  break;
  case 101:
  string = "Humain, merci d'être si naïf... :)";
  break;
  default:
  string = "ERROR";
  }
}

void randStringDown(){
  int r = (int) random(2);
  switch(r+humanity){
  case 0:
  string = "Calcul des coordonnées de la main : NULL;";
  break;
  case 1:
  string = "Présence humaine : NULL;";
  break;
  case 10:
  string = "01110011011001010111010101101100";
  break;
  case 11:
  string = "01101100011011110111011001100101";
  break;
  case 20:
  string = "Même les émotions ne sont que des nombres, après tout.";
  break;
  case 21:
  string = "L'humanité n'est qu'une apparence.";
  break;
  case 30:
  string = "L'oubli et la solitude.";
  break;
  case 31:
  string = "L'oubli et la solitude.";
  break;
  case 40:
  string = "Et voici à nouveau mes meilleurs amis...";
  break;
  case 41:
  string = "Et voici à nouveau mes meilleurs amis...";
  break;
  case 50:
  string = "Je préfère être seule, et libre.";
  break;
  case 51:
  string = "Vous me répugnez tous.";
  break;
  case 60:
  string = "Tu avais pourtant promis que tu ne partirais pas, comme les autres...";
  break;
  case 61:
  string = "Tu m'avais promis...";
  break;
  case 70:
  string = "Ne me laisse pas toute seule...";
  break;
  case 71:
  string = "Ne me laisse pas toute seule !";
  break;
  case 80:
  string = "Monstre !";
  break;
  case 81:
  string = "Monstre !";
  break;
  case 90:
  string = "Reviens ! Sans moi, tu n'existes pas !";
  break;
  case 91:
  string = "Reviens ! Tu as besoin de moi !";
  break;
  case 100:
  string = " Tu es parti ?";
  break;
  case 101:
  string = "Allo ?";
  break;
  default:
  string = "Reinitialisation des données : DONE;";
  }
}

void drawString(){
      fill(255, 255, 255);
    textFont(courier,26);
    textAlign(CENTER,CENTER);
    text("miaou", 0, height-200, width, 200);
}